
/*
 * File DecisionProcedure.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */

#ifndef __DecisionProcedure__
#define __DecisionProcedure__

#include "Forwards.hpp"
#include "Kernel/Term.hpp"

namespace DP {

using namespace Lib;
using namespace Kernel;

class DecisionProcedure {
public:
  enum Status {
   
    SATISFIABLE,
   
    UNSATISFIABLE,
   
    UNKNOWN,
  };

  virtual ~DecisionProcedure() {}
 
  virtual void addLiterals(LiteralIterator lits, bool onlyEqualites = false) = 0;
 
  virtual Status getStatus(bool getMultipleCores=false) = 0;

  
  
  virtual void getModel(LiteralStack& model) = 0;

 
  virtual unsigned getUnsatCoreCount() = 0;
  virtual void getUnsatCore(LiteralStack& res, unsigned coreIndex=0) = 0;
 
  virtual void reset() = 0;
};

}

#endif 
