
/*
 * File Global.cpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#if VDEBUG
#  include "Debug/Assertion.hpp"
#endif

#include "Lib/Enumerator.hpp"

#include "Kernel/Formula.hpp"
#include "Kernel/Unit.hpp"

#include "Shell/UIHelper.hpp"

#include "Lib/Array.hpp"
#include "Lib/Environment.hpp"
#include "Lib/List.hpp"
#include "Lib/System.hpp"



Lib::Enumerator Lib::Enumerator::unitEnumerator;
unsigned Kernel::Unit::_lastNumber = 0;
bool Shell::UIHelper::cascMode=false;
bool Shell::UIHelper::cascModeChild=false;
bool Shell::UIHelper::satisfiableStatusWasAlreadyOutput=false;

Lib::vstring Kernel::Formula::_connectiveNames[] =
  {"atomic", "and", "or", "imp", "iff", "xor", "not", "forall", "exists"};




Lib::ZIArray<Lib::List<VoidFunc>*> Lib::System::s_terminationHandlers(2);

Lib::Environment Lib::env;


struct __Lib_System_Init_Invoker
{
  __Lib_System_Init_Invoker()
  {
    Lib::System::onInitialization();
  }
};

__Lib_System_Init_Invoker __Lib_System_Init_Invoker_obj;

