
/*
 * File MLVariant.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */



#ifndef __MLVariant__
#define __MLVariant__

#include "Forwards.hpp"

namespace Kernel {

using namespace Lib;

class MLVariant {
public:
  static bool isVariant(Literal* const * cl1Lits, Clause* cl2, LiteralList** alts);
  static bool isVariant(Literal* const * cl1Lits, Clause* cl2, bool complementary=false);
  static bool isVariant(Clause* cl1, Clause* cl2, bool complementary=false)
  {
    return cl1->length()==cl2->length() && isVariant(cl1->literals(), cl2, complementary);
  }

};


};

#endif
