
/*
 * File Counter.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __Counter__
#define __Counter__

namespace Lib {

class Counter
{
public:
 
  Counter : _value(0) {}
 
  void inc(int n) { _value += n; }
 
  void inc() { _value++; } 
 
  void dec(int n) { _value -= n; }
 
  void dec() { _value--; }
 
  void reset(int n) { _value = n; }
 
  int value() const { return _value; }
private:
 
  int _value;
}; 

}

#endif


