
/*
 * File FreshnessGuard.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __FreshnessGuard__
#define __FreshnessGuard__

#include "Forwards.hpp"

#include "Debug/Assertion.hpp"

#include "Exception.hpp"

namespace Lib {

class FreshnessGuard {
public:
  FreshnessGuard() : _fresh(true) {}

  bool isFresh() const { return _fresh; }
 
  void use() {
    CALL("FreshnessGuard::use");
    ASS(isFresh());
    if(!isFresh()) {
      INVALID_OPERATION("using non-fresh object");
    }
    _fresh = false;
  }

  void refresh() {
    _fresh = true;
  }

private:
  bool _fresh;
};

}

#endif 
