
/*
 * File Graph.cpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#include "Graph.hpp"

namespace Lib
{

unsigned IntDiGraph::addNode()
{
  CALL("IntDiGraph::addNode");

  unsigned res=_nodeCnt++;
  _neighs.expand(_nodeCnt);
  return res;
}

void IntDiGraph::addEdge(unsigned src, unsigned dest)
{
  CALL("IntDiGraph::addEgde");
  ASS_L(src, _nodeCnt);
  ASS_L(dest, _nodeCnt);

  _neighs[src].push(dest);
  _edges.insert(make_pair(src, dest));
}

unsigned IntDiGraph::edge(unsigned src, unsigned dest)
{
  CALL("IntDiGraph::egde");
  ASS_L(src, _nodeCnt);
  ASS_L(dest, _nodeCnt);

  return _edges.multiplicity(make_pair(src, dest));
}

void IntDiGraph::neighbours(unsigned node, unsigned*& neighArrPtr, unsigned& neighCnt)
{
  CALL("IntDiGraph::neighbours");
  ASS_L(node, _nodeCnt);

  neighCnt=_neighs[node].size();
  neighArrPtr=_neighs[node].begin();
}


IntSubgraph* IntSubgraph::getEmpty()
{
  static IntSubgraph empty;
  return &empty;
}


}
