
/*
 * File MemoryLeak.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */



#ifndef __MemoryLeak__
#define __MemoryLeak__

#if CHECK_LEAKS

#include "Allocator.hpp"
#include "Set.hpp"
#include "Hash.hpp"

#include "Kernel/Unit.hpp"

namespace Kernel {
  class Formula;
};

namespace Lib {

class MemoryLeak
{
public:
  void release(Kernel::UnitList*);
 
  static void cancelReport() { _cancelled = true; }
 
  static bool report() { return ! _cancelled; }
private:
 
  static bool _cancelled;
  void release(Kernel::Formula*);
 
  typedef Set<void*,Hash> PointerSet;
 
  PointerSet _released;
}; 

} 

#endif 
#endif 
