
/*
 * File Random.cpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#include "Debug/Assertion.hpp"
#include "Debug/Tracer.hpp"

#include "Random.hpp"

using namespace Lib;

int Random::_seed = 1;
int Random::_remainingBits = 0;
const int Random::_bitsPerInt = Random::bitsPerInt ();
unsigned Random::_bits;

double Random::getDouble (double min, double max)
{
    CALL("Random::getDouble");
    ASS_L(min, max);

    double diff = max-min;
    double part = (diff*(getInteger(RAND_MAX-2)+1))/RAND_MAX;
    return min+part;
}
long double Random::getDouble (long double min, long double max)
{
    CALL("Random::getDouble");
    ASS_L(min, max);

    long double diff = max-min;
    long double part = (diff*(getInteger(RAND_MAX-2)+1))/RAND_MAX;
    return min+part;
}

int Random::bitsPerInt ()
{
  int b = getMax() + 1;
  int bits = -1;

  while (b != 0) {
    b /= 2;
    bits ++;
  }

  return bits;
} 
