
/*
 * File VString.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */



#ifndef __VString__
#define __VString__

#include <string>
#include <sstream>

#include "STLAllocator.hpp"

namespace Lib {
  

typedef std::basic_ostringstream<char,std::char_traits<char>,STLAllocator<char> > vostringstream_base;

struct vostringstream : public vostringstream_base {
  CLASS_NAME(vostringstream);
  USE_ALLOCATOR(vostringstream);
  
  
  using vostringstream_base::vostringstream_base;
};


typedef std::basic_istringstream<char,std::char_traits<char>,STLAllocator<char> > vistringstream_base;

struct vistringstream : public vistringstream_base {
  CLASS_NAME(vistringstream);
  USE_ALLOCATOR(vistringstream);
  
  
  using vistringstream_base::vistringstream_base;
};


typedef std::basic_stringstream<char,std::char_traits<char>,STLAllocator<char> > vstringstream_base;

struct vstringstream : public vstringstream_base {
  CLASS_NAME(vstringstream);
  USE_ALLOCATOR(vstringstream);
  
  
  using vstringstream_base::vstringstream_base;
};


typedef std::basic_string<char,std::char_traits<char>,STLAllocator<char> > vstring;


} 

#endif 
