
/*
 * File DIMACS.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __DIMACS__
#define __DIMACS__

#include "Forwards.hpp"
#include "Lib/VirtualIterator.hpp"

#include "SATClause.hpp"

namespace SAT
{

class DIMACS
{
public:
  static SATClauseList* parse(const char* fname, unsigned& maxVar);

  static void outputGroundedProblem(MapToLIFO<Clause*, SATClause*>& insts,
	  SATClause::NamingContext& nctx, ostream& out);
  static void outputProblem(SATClauseList* clauses, ostream& out);

private:
  static void getStats(SATClauseIterator clauses, unsigned& clauseCnt, unsigned& maxVar);
};

}

#endif
