
/*
 * File LingelingInterfacing.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */

#ifndef __LingelingInterfacing__
#define __LingelingInterfacing__

#include "Forwards.hpp"

#include "Lib/Allocator.hpp"
#include "Shell/Options.hpp"

#include "SATSolver.hpp"
#include "SATLiteral.hpp"
#include "SATClause.hpp"


struct LGL;

namespace SAT{
  
class LingelingInterfacing : public PrimitiveProofRecordingSATSolver
{
public: 
  CLASS_NAME(LingelingInterfacing);
  USE_ALLOCATOR(LingelingInterfacing);

	LingelingInterfacing(const Shell::Options& opts, bool generateProofs=false) {}
	
	void addClause(SATClause* cl)  {}
  Status solve(unsigned conflictCountLimit)  { return UNKNOWN; }
  void ensureVarCount(unsigned newVarCnt)  {}
  unsigned newVar() override { return 0; }
  void suggestPolarity(unsigned var, unsigned pol)  {}
	VarAssignment getAssignment(unsigned var) { return NOT_KNOWN; }
	bool isZeroImplied(unsigned var) { return false; }
	void collectZeroImplied(SATLiteralStack& acc) {}
	SATClause* getZeroImpliedCertificate(unsigned var){ return 0; }
	void addAssumption(SATLiteral literal) {}
	void addCAssumption(SATClause* clause, unsigned conflictingCountLimit) {}
	void retractAllAssumptions() {}
	bool hasAssumptions() const { return false; }
	void recordSource(unsigned var, Literal* lit) {}
	Status solveUnderAssumptions(const SATLiteralStack& assumps, unsigned conflictCountLimit, bool)  { return UNKNOWN; }
};

}

 #endif
