
/*
 * File BFNTMainLoop.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __BFNTMainLoop__
#define __BFNTMainLoop__

#include "Lib/Portability.hpp"

#include "Forwards.hpp"

#include "Lib/SmartPtr.hpp"

#include "Kernel/MainLoop.hpp"

#include "BFNT.hpp"
#include "Options.hpp"

namespace Shell {

using namespace Lib;
using namespace Kernel;

class BFNTMainLoop : public MainLoop {
public:
  CLASS_NAME(BFNTMainLoop);
  USE_ALLOCATOR(BFNTMainLoop);     
  
  BFNTMainLoop(Problem& prb, const Options& opt);

protected:
  virtual void init();
  virtual MainLoopResult runImpl();

private:

 
  bool _hasSorts;

#if !COMPILER_MSVC
  void runChild(size_t modelSize) __attribute__((noreturn));
  MainLoopResult spawnChild(size_t modelSize);

  Options _childOpts;
 
  BFNT _bfnt;
#endif
};

}

#endif 
