
/*
 * File ConstantRemover.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __ConstantRemover__
#define __ConstantRemover__
#if GNUMP

#include "Forwards.hpp"

#include "Lib/DArray.hpp"

namespace Shell {

using namespace Lib;
using namespace Kernel;

class ConstantRemover {
public:
  ConstantRemover();

  bool apply(ConstraintRCList*& lst);
private:
  void reset();
  bool scan(ConstraintRCList* lst);

  struct DefiningPair {
    DefiningPair() : left(0), right(0), isTight(false) {}

    ConstraintRCPtr left;
    ConstraintRCPtr right;

    bool isTight;
  };

  Var _varCnt;
  DArray<DefiningPair> _vals;
};

}
#endif 
#endif 
