
/*
 * File EqualityVariableRemover.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __EqualityVariableRemover__
#define __EqualityVariableRemover__
#if GNUMP
#include "Forwards.hpp"

#include "Lib/Set.hpp"

#include "Kernel/V2CIndex.hpp"

namespace Shell {

using namespace Lib;
using namespace Kernel;

class EqualityVariableRemover {
public:
  EqualityVariableRemover() { reset(); }

  bool apply(ConstraintRCList*& lst);
private:
  void reset();
  void scan(ConstraintRCList* lst);

  Var getEliminatedVariable(Constraint& c);

  void eliminate(Constraint* c, ConstraintRCList*& lst);

  bool allowedEquality(Constraint& c);

  struct ConstraintHash
  {
    static unsigned hash(const Constraint* c);
    static bool equals(const Constraint* c1, const Constraint* c2);
  };

  Set<Constraint*,ConstraintHash> _halves;
  DHMap<Constraint*, Constraint*> _equalities;
  V2CIndex _v2c;
};

}
#endif 
#endif 
