
/*
 * File FormulaIteExpander.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __FormulaIteExpander__
#define __FormulaIteExpander__

#include "Forwards.hpp"

namespace Shell {

using namespace Kernel;

class FormulaIteExpander {
public:
  FormulaIteExpander() : _defs(0) {}

  void apply(Problem& prb);
  bool apply(UnitList*& units);
  Unit* apply(Unit* unit, UnitList*& defs);
  FormulaUnit* apply(FormulaUnit* unit, UnitList*& defs);
private:
  FormulaUnit* apply(FormulaUnit* unit);
  Formula* apply(Formula* f);
  FormulaList* apply(FormulaList* fs);
  Formula* makeBinaryJunction(Connective con, Formula* f1, Formula* f2);
  Formula* introduceDefinition(Formula* f);

  UnitList* _defs;
};

}

#endif 
