
/*
 * File PDUtils.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __PDUtils__
#define __PDUtils__

#include "Forwards.hpp"



namespace Shell {

using namespace Lib;
using namespace Kernel;

class PDUtils {
 
  PDUtils() {}
public:

  static bool isDefinitionHead(Literal* l);

  static bool isUnitAtom(FormulaUnit* unit, Formula*& atom);

  static bool isAtomBinaryFormula(FormulaUnit* unit, Connective& con, Formula*& f1, Formula*& f2);
  static bool isAtomEquivalence(FormulaUnit* unit, Formula*& f1, Formula*& f2);
  static bool isAtomEquivalence(FormulaUnit* unit, Literal*& l1, Literal*& l2);

  static bool isPredicateEquivalence(FormulaUnit* u);
  static bool isPredicateEquivalence(FormulaUnit* u, unsigned& pred1, unsigned& pred2);
  static bool isPredicateEquivalence(FormulaUnit* u, Literal*& lit1, Literal*& lit2);
  static bool isPredicateEquivalence(FormulaUnit* u, Formula*& f1, Formula*& f2);

  static void splitDefinition(FormulaUnit* unit, Literal*& lhs, Formula*& rhs);

  static bool hasDefinitionShape(Unit* unit);
  static bool hasDefinitionShape(FormulaUnit* unit);
  static bool hasDefinitionShape(Literal* lhs, Formula* rhs);
};

}

#endif 
