
/*
 * File SMTPrinter.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __SMTPrinter__
#define __SMTPrinter__

#include <iosfwd>

#include "Forwards.hpp"
#include "SineUtils.hpp"


#include "Kernel/Signature.hpp"


namespace Shell {

using namespace Kernel;

class SMTPrinter {
public:
    
  typedef Signature::Symbol Symbol;
  
  SMTPrinter();
  void smtPrint(Formula* formula, ostream& out);
  void smtPrint(Term* term, ostream& out);
  void smtPrint(Symbol* symb, ostream& out);
  void smtPrintName(const vstring& name, ostream& out);
  void smtPrintSort(const vstring& sortName, ostream& out);  
  void smtPrintDeclaration(Symbol* symb, ostream& out);

private:

  FormulaList* _formulas;
  Set<Symbol*>* _symbols;
  Set<Symbol*>* _predicates;
  bool _getProof;
  bool _smtlib2;
};

}

#endif 
