
/*
 * File Token.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-25. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-25 only because so is required by the CASC-25
 * rules, and for no other reason.
 */


#ifndef __Token__
#define __Token__

#include "Lib/VString.hpp"

namespace Shell {

enum TokenType {
 
  TT_INTEGER,
 
  TT_REAL,
 
  TT_LPAR,
 
  TT_RPAR,
 
  TT_LBRA,
 
  TT_RBRA,
 
  TT_COMMA,
 
  TT_COLON,
 
  TT_DOT,
 
  TT_AND,
 
  TT_NOT,
 
  TT_OR,
 
  TT_IFF,
 
  TT_IMP,
 
  TT_REVERSE_IMP,
 
  TT_XOR,
 
  TT_FORALL,
 
  TT_EXISTS,
 
  TT_TRUE,
 
  TT_FALSE,
 
  TT_PP,
 
  TT_MM,
 
  TT_EQUAL,
 
  TT_NEQ,
 
  TT_NAME,
 
  TT_VAMPIRE,
 
  TT_VAR,
 
  TT_INPUT_FORMULA, 
 
  TT_INPUT_CLAUSE,
 
  TT_CNF,
 
  TT_INCLUDE,
 
  TT_EOF,
  
 
  TT_ROW_VARIABLE,
 
  TT_STRING,
 
  TT_QUOTED_STRING,
 
  TT_GREATER_THAN,
 
  TT_GEQ,
 
  TT_LESS_THAN,
 
  TT_LEQ,
 
  TT_END_OF_EMPTY_TAG,
 
  TT_TEXT,
 
  TT_CLOSING_TAG,
 
  TT_PLUS,
 
  TT_MINUS,
 
  TT_DISTINCT,
 
  TT_LBLPOS,
 
  TT_LBLNEG,
 
  TT_LEMMA,
 
  TT_PROOF,
 
  TT_PUSH,
 
  TT_POP,
 
  TT_PATTERN,
 
  TT_DEFPRED,
 
  TT_DEFPREDMAP,
 
  TT_PROMPTON,
 
  TT_PROMPTOFF,
 
  TT_ORDER,
 
  TT_EXPLIES,
 
  TT_ADD_CONSTANT,
 
  TT_ADD_VARIABLE,
 
  TT_ADD_DEF_VARIABLE,
 
  TT_ADD_EQUAL,
 
  TT_ADD_BIT_NOT,
 
  TT_ADD_BIT_AND,
 
  TT_ADD_BIT_OR,
 
  TT_ADD_BIT_XOR,
 
  TT_ADD_LOGICAL_NOT,
 
  TT_ADD_LOGICAL_AND,
 
  TT_ADD_LOGICAL_OR,
 
  TT_ADD_LOGICAL_IMPLIES,
 
  TT_ADD_LESS_THAN,
 
  TT_ADD_LESS_EQUAL,
 
  TT_ADD_GREATER_THAN,
 
  TT_ADD_GREATER_EQUAL,
 
  TT_ADD_SUB,
 
  TT_ADD_SUM,
 
  TT_ADD_MUL,
 
  TT_ADD_DIV,
 
  TT_ADD_MOD,
 
  TT_ADD_LSHIFT,
 
  TT_ADD_RSHIFT,
 
  TT_ADD_LSHIFT1,
 
  TT_ADD_RSHIFT1,
 
  TT_ADD_ASSIGNMENT,
 
  TT_ADD_CONCAT_OP,
 
  TT_ADD_CONDITION,
 
  TT_ADD_ZERO_EXTENSION,
 
  TT_ADD_SIGN_EXTENSION,
 
  TT_ADD_DEF_UF,
 
  TT_ADD_UF_ARG,
 
  TT_ADD_UF_TERM_ARG,
 
  TT_ADD_LATCH,
 
  TT_ADD_UF_TERM,
 
  TT_ADD_ASSUMPTION,
 
  TT_ATTRIBUTE,
 
  TT_ARITH,
 
  TT_USER
}; 


class Token 
{
public:
  TokenType tag;
  Lib::vstring text;
  int line;

  static Lib::vstring toString (TokenType);
};

}

#endif 
